您的位置:首页 > 其它

【Leetcode】Combination sum 1,2

2015-08-24 16:47 323 查看
【题目】

【分析】

首先,先sort,

如果target > 0:

【代码】

using recursive 这恐怕的 O(n2)...

过程:

before recursion : [2]
before recursion : [2, 2]
before recursion : [2, 2, 2]
after recursion and remove : [2, 2]
before recursion : [2, 2, 3]
after recursion and remove : [2, 2]
after recursion and remove : [2]
before recursion : [2, 3]
after recursion and remove : [2]
after recursion and remove : []
before recursion : [3]
before recursion : [3, 3]
after recursion and remove : [3]
after recursion and remove : []
before recursion : [6]
after recursion and remove : []
before recursion : [7]
after recursion and remove : []
[[2, 2, 3], [7]]

public class Solution {
public List<List<Integer>> combinationSum(int[] candidates, int target) {
Arrays.sort(candidates);
List<List<Integer>> result = new ArrayList<List<Integer>>();
getResult(result, new ArrayList<Integer>(), candidates, target, 0);

return result;
}

private void getResult(List<List<Integer>> result, List<Integer> cur, int candidates[], int target, int start){
if(target > 0){
for(int i = start; i < candidates.length && target >= candidates[i]; i++){
cur.add(candidates[i]);
getResult(result, cur, candidates, target - candidates[i], i);
cur.remove(cur.size() - 1);
}//for
}//if
else if(target == 0 ){
result.add(new ArrayList<Integer>(cur));
}//else if
}
}


【二】

【题目】

Given a collection of candidate numbers (C) and a target number (T),find all unique combinations in C where the candidate numbers sums to T.

Each number in C may only be used once in the combination.

Note:

All numbers (including target) will be positive integers.

Elements in a combination (a1, a2, … , ak) must be in non-descending order. (ie, a1 ≤ a2 ≤ … ≤ ak).

The solution set must not contain duplicate combinations.

For example, given candidate set 10,1,2,7,6,1,5 and target 8,

A solution set is:

[1, 7]

[1, 2, 5]

[2, 6]

[1, 1, 6]

【题目】

题意分析:从给定数组中找到一组数字,要求这组数字之和等于target。另外,数组中的数字不允许被使用多次,但如果一开始就存在多个的话,可以使用多次。

解题思路:显然先排序,然后dfs。其中有一点要注意的是:因为不能重复,所以要跳过一样的数字。以上面为例,如果不跳过重复的1的话,会出现多个:[1,7]

public static void dfs(int [] num, int start, int target, List<Integer> array, List<List<Integer>> result) {
if(target==0) {
result.add(new ArrayList<Integer>(array));
return;
}

if(start>=num.length||num[0]>target) {
return;
}
int i = start;
while(i<num.length) {
if(num[i]<=target) {
array.add(num[i]);  System.out.println("before dfs: " + array);
dfs(num, i + 1, target - num[i], array, result);
array.remove(array.size()-1);  System.out.println("after dfs and rempve: " + array);
//跳过重复的元素
while(i<(num.length-1)&&num[i]==num[i+1]) {
i++;
}
}
i++;
}
}

public static List<List<Integer>> combinationSum2(int[] num, int target) {
List<List<Integer>> result = new ArrayList<List<Integer>>();
ArrayList<Integer> array = new ArrayList<Integer>();
if(num==null) {
result.add(array);
return result;
}
Arrays.sort(num);
dfs(num,0, target,array,result);
return result;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode